/*                            CWIO.C                                    */

#include <unistd.h>
#include <asm/io.h>
#include "cwrx.h"

/*
 * Investigating the status of the key
 */
 
int key(int port) {
  unsigned char ch;
                                          /* Allow access to port */
  ioperm(port+1,1,1);
                                          /* Reading the port status */
  ch = inb(port+1);
                                          /* Prohibit further access */
  ioperm(port+1,1,0);
                                          /* bit 5 down if the key
					     depressed               */
  ch &= 0x20;
  return (ch ? UP : DOWN);
}

/*
 * Pull up the pin into which the key is connected.
 * This is to avoid hum problems. There must be abt. 1k resistor
 * connected between pins 9 and 12 of the printer port. In addition
 * to this, abt. .1 uF condensator between pins 12 and 25 must be
 * in place.
 */

void pullup(int port) {
  unsigned char ch;
                                         /* Allow access */
  ioperm(port,1,1);                   
                                         /* Read the data register */
  ch = inb(port);
                                         /* Raise up bit 7 */
  ch |= 0x80;
                                         /* And put it back */
  outb(ch,port);
                                         /* Prohibit further access */
  ioperm(port,1,0);
}



